#
#  bfp_ps_lib.pl - simple postscript functions for fast_pan/blast_pan
#
#   $Name: HEAD $ - $Id: bfp_ps_lib.pl,v 1.2 2000/06/16 17:50:56 wrp Exp $
#

sub ps_header {
    my ($opt_post, $xh, $xr, $sqi_cut, $opt_col) = @_;
    my ($red, $green, $blue, $l_color);

    $date = `date`;

    if ($opt_col > 5) {$opt_col = 2;}

    $l_color ="/l_color { [ 0.2  0.2  0.2  0.2  0.2  0.2  0.2  0.2  ] } def";

    if ($opt_col == 0) {
	$red ="/r_color { [ 0.2 0.2 0.2 0.2 0.8 0.8 0.8 0.5 ] } def";
	$green="/g_color { [ 0.2 0.2 0.8 0.8 0.2 0.2 0.8 0.5 ] } def";
	$blue="/b_color { [ 0.2 0.8 0.2 0.8 0.2 0.8 0.2 0.5 ] } def";
    }

    if ($opt_col== 1) {
	$red="/r_color { [ 0.0 0.0 0.2 0.0 0.5 0.50 1.00 1.0 ] } def";
	$green="/g_color { [ 0.0 0.0 0.2 1.0 0.5 0.25 0.33 0.0 ] } def";
	$blue="/b_color { [ 0.0 1.0 0.8 0.0 0.0 0.0  0.00 0.0 ] } def";
    }

    if ($opt_col== 2) {
	$red="/r_color { [ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 0.5 ] } def";
	$green="/g_color { [ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 0.5 ] } def";
	$blue="/b_color { [ 0.0 1.0 0.0 1.0 0.0 1.0 0.0 0.5 ] } def";
    }

    if ($opt_col== 3) {
	$red="/r_color { [ 0.2 1.0 1.0 0.4 0.4 0.4 1.0 0.5 ] } def";
	$green="/g_color { [ 0.2 0.4 1.0 1.0 1.0 0.4 0.4 0.5 ] } def";
	$blue="/b_color { [ 0.2 0.4 0.4 0.4 1.0 1.0 1.0 0.5 ] } def";
    }
    if ($opt_col== 4) {
	$red="/r_color { [ 0.2 1.0 1.0 0.0 0.0 0.0 1.0 0.5 ] } def";
	$green="/g_color { [ 0.2 0.0 1.0 1.0 1.0 0.0 0.0 0.5 ] } def";
	$blue="/b_color { [ 0.2 0.0 0.0 0.0 1.0 1.0 1.0 0.5 ] } def";
    }
    if ($opt_col== 5) {
	$red="/r_color { [ 0.2 0.6 0.6 0.0 0.0 0.0 0.6 0.5 ] } def";
	$green="/g_color { [ 0.2 0.0 0.6 0.6 0.6 0.0 0.0 0.5 ] } def";
	$blue="/b_color { [ 0.2 0.0 0.0 0.0 0.6 0.6 0.6 0.5 ] } def";
    }

    print PSFILE <<POST_EOF;
%!PS-Adobe-2.0
%%Creator: blast_pan.pl
%%Title: $opt_post
%%CreationDate: $date
%%PageOrder: Ascend
%%EndComments
%
% disable PDFmark if it is not present
%
/pdfmark where
{pop} {userdict /pdfmark /cleartomark load put} ifelse

% - the general link method for pdfmark
%  [ /Rect [ llx lly urx ury ]
%    /Action << /Subtype /URI /URI (http://www.adobe.com) >>
%    /Subtype /Link
%    /ANN
%   pdfmark
%
%
% postscript to display histogram profiles of EST's
%
% scale/size variables
%
/ys 1 def       % y-scaling \(1 pt = 1 y-unit\)
/xh $xh def       % histogram bar width
/xr $xr def       % spacing between labels, histogram bars
/xo 0 def % xstart position (0,?) for plot, must be reset to 0 each time
/yo 0 def % ystart position (?,0) for plot, must be reset to 0 each time
/sz $xh def       % size of diagonal label text
/szd 3  def     % diagonal offset
/sl 10 def      % size of EST plot label
$red
$green
$blue
$l_color

/yaxis {
        0 0 moveto
        0 100 lineto
        stroke
	-30 25 moveto
	(Log(Expect)) vprint
        newpath
        0 15.05 moveto
        -3 0 rlineto gsave stroke grestore
        (-2) dup stringwidth pop neg -3 add -5 rmoveto show
        0 34.95 moveto
        -3 0 rlineto gsave stroke grestore
        (-5) dup stringwidth pop neg -3 add -5 rmoveto show
        0 50 moveto
        -3 0 rlineto gsave stroke grestore
        (-10) dup stringwidth pop neg -3 add -5 rmoveto show
        0 65.05 moveto
        -3 0 rlineto gsave stroke grestore
        (-20) dup stringwidth pop neg -3 add -5 rmoveto show
        0 84.9 moveto
        -3 0 rlineto gsave stroke grestore
        (-50) dup stringwidth pop neg -3 add -5 rmoveto show
        0 100 moveto
        -3 0 rlineto gsave stroke grestore
        (-100) dup stringwidth pop neg -3 add -5 rmoveto show
        } def
%
%
/y2axis {
        xo 0 moveto
        0 100 rlineto
        stroke
	xo 30 add 35 moveto
	(% ident) vprint
        newpath
        xo 0 moveto
        3 0 rlineto gsave stroke grestore
        (0) 1 -5 rmoveto show
        xo 10.56 moveto
        3 0 rlineto gsave stroke grestore
        (20) 1 -5 rmoveto show
        xo 22.54 moveto
        3 0 rlineto gsave stroke grestore
        (40) 1 -5 rmoveto show
        xo 36.75 moveto
        3 0 rlineto gsave stroke grestore
        (60) 1 -5 rmoveto show
        xo 55.28 moveto
        3 0 rlineto gsave stroke grestore
        (80) 1 -5 rmoveto show
        xo 68.38 moveto
        3 0 rlineto gsave stroke grestore
        (90) 1 -5 rmoveto show
        xo 77.64 moveto
        3 0 rlineto gsave stroke grestore
        (95) 1 -5 rmoveto show
        xo 90.00 moveto
        3 0 rlineto gsave stroke grestore
        (99) 1 -5 rmoveto show
        xo 100 moveto
        3 0 rlineto gsave stroke grestore
        (100) 1 -5 rmoveto show
        } def
%

%
% (label) -LogE f_start f_end color -Log(id) hbox
%
/hbox {
        /c exch def
        /sp exch def
        /st exch def
        sp 1.0 ge { /sp 1.0 def } if
        st 0.0 le { /st 0.0 def } if
	/sqi exch def
        /as exch def
	/urlstr exch def
        /sd sp st sub as mul ys mul def
        sd 2 lt { /sd 1 def } if

        as 0 gt {
         gsave
         c                       % [c]
         dup r_color             % [c][c] [r_color]
         exch                    % [c][r_color][c]
         get                     % [c][r]
         exch                    % [r][c]
         dup b_color exch get exch  % get g_color
         g_color exch get exch  % get b_color
         setrgbcolor
         newpath
         xo st as mul ys mul  moveto
         0 sd rlineto
         xh 0 rlineto
         0 sd neg rlineto
         closepath
         fill
         stroke
         newpath		% write horizontal line for % ident
         l_color c get setgray	% get line color (l_color)
         xo 1.5 add sqi ys mul yo add moveto
         xh 3 sub 0 rlineto
	 1.5 setlinewidth
         stroke

	 sqi $sqi_cut gt { xo xh 4 div add 96 moveto 
		/Helvetica findfont 18 scalefont setfont (*) hprint } if

         grestore
        } if
        gsave
        1.25 setlinewidth
        newpath
         xo yo moveto
         0 as ys mul rlineto
         xh 0 rlineto
         0 as neg ys mul rlineto
         closepath

%	 pathbbox 
%	 /rury exch def
%	 /rurx exch def
%	 /rlly exch def
%	 /rllx exch def

         stroke
         grestore

%	[ /Rect [ rllx rlly rurx rury ]
%	/Action << /Subtype /URI /URI urlstr >>
%	/Subtype /Link
%	/ANN
%	pdfmark

        /xo xo xr add def
} def

% header for all data
%
/right { 0 rmoveto } def
/down { neg 0 exch rmoveto } def
/cm { 2.54 div 72 mul } def
/vprint { gsave 90 rotate show newpath stroke grestore } def
/dprint { gsave 45 rotate show newpath stroke grestore } def
/hrprint {
	gsave
	dup stringwidth pop neg 0 rmoveto
	show 
	grestore
	} def

/dprintr {
        gsave
        dup r_color exch get exch  % get g_color
        dup b_color exch get exch  % get g_color
        g_color exch get exch  % get g_color
        setrgbcolor
        45 rotate show
        newpath
        stroke grestore xr 0 rmoveto } def
/hprint { gsave show newpath stroke grestore } def
/nstr 7 string def
%%EndProlog

POST_EOF


} #close sub header

################################################################
#
# passes $opt_ps_head, $page, $l_margin, $r_margin
# uses @search_seq, %color;
################################################################
sub ps_page {

    my ($opt_ps_head, $page, $r_margin) = @_;
    my ($l_margin, $s_name);

    print PSFILE <<POST_EOF;
%%Page: $page $page
/xo 0 def % xstart position (0,?) for plot, must be reset to 0 each time
/yo 0 def % ystart position (?,0) for plot, must be reset to 0 each time
/Helvetica findfont sz scalefont setfont
1 setlinewidth
% this section moves to the top of a page
% then moves to the top of a panel and labels the columns
$r_margin 600 translate
xh 2 div 120 moveto    % 0 120 move to top of panel

POST_EOF
    
    if ($opt_ps_head) {
	$l_margin = 612-2*$r_margin; # doubled because of translate above
	print PSFILE "$l_margin 160 moveto\n";
	print PSFILE "($opt_ps_head) hrprint\n";
	print PSFILE "xh 2 div 110 moveto\n";
    }

    foreach $s_name ( @search_seq ) {
	if ($s_name) {
	    print PSFILE "($s_name) $color{$s_name} dprintr\n";
	}
    } 
    print PSFILE "% labels are finished (use above section for each page)\n";

} #close sub page


################################################################

sub ps_footer {

    print PSFILE <<POST_EOF;
%%Trailer

%%EOF

POST_EOF

} #close sub footer

sub ps_panel {

    print PSFILE <<POST_EOF;
% put on the y-axis
/xo 0 def
/yo 0 def
0 0 moveto
% 0 100 lineto (done by yaxis)
yaxis
POST_EOF

}

sub ps_panel_end {

    my ($l_name, $line, $lt_name, $q_total, $xr) = @_;
    my $urx_pos;
#
#  finish the postscript panel
#
    print PSFILE "y2axis\n";
    print PSFILE "% label the panel with EST name\n";
    print PSFILE "18 -12 moveto\n";
    print PSFILE "gsave\n";
    print PSFILE "/Helvetica findfont sl scalefont setfont\n";
    $line =~ s/\(//g;
    $line =~ s/\)//g;
    $line = substr($line,0,60);
    print PSFILE "($l_name $line) hprint\n";
    print PSFILE "grestore\n\n";
#
# now point to the results page
#
    $urx_pos = $q_total * $xr;
    print PSFILE "[ /Rect [ 0 0 $urx_pos 100 ]\n";
    print PSFILE "/Action << /Subtype /URI /URI ($lt_name) >>\n";
    print PSFILE "/Subtype /Link\n/ANN pdfmark\n";

    if (($l_count % 5) == 4) {
	print PSFILE "showpage\n";
	$page++;
    }
    else {
	print PSFILE "0 -135 translate\n";
    }
}

sub ps_nohit_panel {

print PSFILE <<"POST_EOF"
% put on the y-axis
/xo 0 def
/yo 0 def
120 40 moveto
/Helvetica findfont 24 scalefont setfont
(No matches found) show
showpage

POST_EOF
}

1;
