#!/usr/local/bin/perl

################################################################
#
# extractzp.pl  seq1
# gets sequences from the ncbi/entrez WWW server in fasta format
# extractzp.pl normally sends results to a file called "seq1", but 
#
# sends to "stdout" if extractzp.pl - is used.
#
################################################################


use LWP::Simple;

$use_stdout = 0;

if ($ARGV[0] =~ /^-/) {
    $use_stdout = 1;
    shift(@ARGV);
}

foreach $n ( @ARGV ) {
    $gid = $n;
    $gid =~ s/^gi_/gi|/;
    $url="http://www.ncbi.nlm.nih.gov/htbin-post/Entrez/query?db=p&form=6&Dopt=f&html=no&uid=$gid";

    $ofn = $n;
    $ofn =~ tr/A-Z/a-z/;
    if ($use_stdout != 1) {
	open(OUT, "> $ofn") || die "cannot open $ofn for output\n";
    }

#print STDERR "Contacting NCBI ...\n\n";

    @entry = split(/\n/,(get $url));

    if ($entry[0] =~/^ERROR/) {
    print "ERROR - $n not found\n";
    }

    $have_gt = 0;
    for $l (@entry) {
	if ($l=~/^>/) {$have_gt = 1;}
	if ($have_gt == 1) { ($use_stdout==1) ?
				 print STDOUT "$l\n": print OUT "$l\n";}
    }

    if ($use_stdout!=1) {close(OUT);}
}
